# SPDX-FileCopyrightText: ☭ Emery Hemingway
# SPDX-License-Identifier: Unlicense

## Syndicate multitool.

import syndicate, syndicate/relays, syndicate/drivers/timers

const
  withPostgre* {.booldefine.}: bool = true
  withSqlite* {.booldefine.}: bool = true

import ./syndesizer/[
  cache_actor,
  file_system_usage,
  json_socket_translator,
  json_translator,
  pulses,
  xml_translator,
  xslt_actor]

when withPostgre:
  import ./syndesizer/postgre_actor

when withSqlite:
  import ./syndesizer/sqlite_actor

runActor("syndesizer") do (turn: var Turn):
  resolveEnvironment(turn) do (turn: var Turn; ds: Cap):
    discard spawnTimerDriver(turn, ds)
    discard spawnCacheActor(turn, ds)
    discard spawnFileSystemUsageActor(turn, ds)
    discard spawnJsonSocketTranslator(turn, ds)
    discard spawnJsonStdioTranslator(turn, ds)
    discard spawnPulseActor(turn, ds)
    discard spawnXmlTranslator(turn, ds)
    discard spawnXsltActor(turn, ds)
    when withPostgre:
      discard spawnPostgreActor(turn, ds)
    when withSqlite:
      discard spawnSqliteActor(turn, ds)
